package com.ruoyi.platform.mapper;

import com.ruoyi.platform.domain.Experiment;
import com.ruoyi.platform.domain.Workflow;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * DAG workflow(Workflow)表数据库访问层
 *
 * @author makejava
 * @since 2023-10-18 14:17:10
 */
public interface WorkflowDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Workflow queryById(Long id);

    /**
     * 查询指定行数据
     *
     * @param workflow 查询条件
     * @param pageable 分页对象
     * @return 对象列表
     */
    List<Workflow> queryAllByLimit(@Param("workflow") Workflow workflow, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数 实体作为筛选条件
     *
     * @param workflow 查询条件
     * @return 总行数
     */
    long count(@Param("workflow") Workflow workflow);


    /**
     * 统计流水线总数
     *
     *
     * @return 总行数
     */
    long workflowCount();




    /**
     * 新增数据
     *
     * @param workflow 实例对象
     * @return 影响行数
     */
    int insert(@Param("workflow") Workflow workflow);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<Workflow> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<Workflow> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<Workflow> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<Workflow> entities);

    /**
     * 修改数据
     *
     * @param workflow 实例对象
     * @return 影响行数
     */
    int update(@Param("workflow") Workflow workflow);

    /**
     * 通过名字模糊查询
     *
     * @param name 主键
     * @return 对象列表
     */
    List<Workflow> queryByName(@Param("name") String name);

    Workflow findByName(@Param("name") String name);

}

